#include <string>
#include "javaMessages.cpp"

/***
 * A base class for wrappers to a c++ program for java communication
 * communication occurs using javaMessage objects.
 * Implemented by fibWrapper.cpp
 *
 * @author K Ericson
 */


#ifndef _WRAPPER_CPP_
#define _WRAPPER_CPP_

class wrapper{
public:
	std::string getStatus();
	void run(javaMessage); //grabs input from the javaMessage
	void stop();
	void abort();
	void getResults(javaMessage&);
	void initialize(javaMessage);

private:
	std::string status;
	long results;
	std::string attachedStream;
	long input;

};

#endif //_WRAPPER_CPP_
