# handles constants for java messages, creates an enum
# uses the construct package.
# -K Ericson ericson@cs.colostate.edu

from construct import *

class controlMessage:
	"""Constants contained in a control message"""
	mType = Enum(SBInt32("MessageType"),
		ABORT = 0,
		START_STOP = 1,
		PAUSE_RESUME = 2,
		STATUS = 3,
		COMPLETE = 4,
		DATA = 5,
		RESULTS = 6,
		INITIALIZE = 7,
		CHANGE_BRIDGE_TYPE = 8,
		_default_ = "undefinedType",
		)
	"""Data Type constants"""
	dType = Enum(SBInt32("DataType"),
		LONG = -1,
		STRING = -2,
		INT = -3,
		_default_ = "undefinedDType",
		)
	"""Communication Type Constants"""
	cType = Enum(SBInt32("CommunicationType"),
		UPIPES = 0,
		NPIPES = 1,
		TCP = 2,
		UDP = 3,
		SHAREDMEM = 4,
		_default_= "undefinedCommType",
		)
