#code to handle converting to/from a java message

from construct import *
from controlMessage import *

class javaMessage:
	_cm_ = controlMessage()
	"""Sets up construct to handle conversion to/from javaMessages"""
	IOArrays = Struct("IOArray",
		SBInt32("length"),
		MetaField("data", lambda ctx: ctx.length),
	)

	JMConvert = Struct("jmConvert",
		_cm_.mType,
		StrictRepeater(2,IOArrays), #for input and output byte[] arrays
		PascalString("StreamID",length_field=SBInt32("length")),
		PascalString("Description",length_field=SBInt32("length")),
		Flag("fromJava"),
	)
	
	#helpers to handle conversions to bytes for Input/output

	readOne = Struct("readOne",
		_cm_.dType,
		Switch("data",lambda ctx: ctx.DataType,
			{
				"LONG" : SBInt64("ld"),
				"STRING" : PascalString("sd",length_field=SBInt32("length")),
				"INT" : SBInt32("id"),
			},
			default = SBInt32("err")
		)
	)

	"""Handles a block of input or output data - only put in data field of a IOArray, don't need full size info"""
	dataBlock = Struct("dataBlock",
		OptionalGreedyRepeater(readOne),
	)

	finalBuild = Struct("final",
		SBInt32("length"),
		MetaField("data", lambda ctx: ctx.length),
	)
