/**
 * Software License, Version 1.0
 * 
 * Copyright 2008 The Trustees of Indiana University.  All rights reserved.
 * 
 *
 *Redistribution and use in source and binary forms, with or without 
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the 
 * following acknowledgment:
 *
 *"This product includes software developed by the Community Grids Lab. For 
 * further information contact the Community Grids Lab at 
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgment may appear in the software itself, and 
 * wherever such third-party acknowledgments normally appear.
 * 
 *4) The name Indiana University or Community Grids Lab or Granules, 
 * shall not be used to endorse or promote products derived from this software 
 * without prior written permission from Indiana University.  For written 
 * permission, please contact the Advanced Research and Technology Institute 
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called Granules, 
 * nor may Indiana University or Community Grids Lab or Granules appear
 * in their name, without prior written permission of ARTI.
 * 
 *
 * Indiana University provides no reassurances that the source code provided 
 * does not infringe the patent or any other intellectual property rights of 
 * any other entity.  Indiana University disclaims any liability to any 
 * recipient for claims brought by any other entity based on infringement of 
 * intellectual property rights or otherwise.  
 *
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO 
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF 
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS. 
 * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS", 
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.  
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR 
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION 
 * GENERATED USING SOFTWARE.
 */
package ds.granules.naadsm.dynamicmerge;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

import ds.granules.naadsm.dynamicmerge.event.OutputVariableValue;

/**
 * This class transforms the raw output data from the Controller and Workers
 * into a training data file that can be used to train a learning algorithm.
 * 
 * @author simonsui
 * 
 */
public class DataPrepare {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		int numFeatures = OutputVariableValue.VAR_NUM;
		double a[][] = new double[1000000][numFeatures + 1];
		double b[][] = new double[1000000][1];
		double tmp[] = new double[1000000];
		ArrayList<Double> array = new ArrayList<Double>();
		HashMap<Integer, ArrayList<Double>> hashMap = new HashMap<Integer, ArrayList<Double>>();
		// File source = new File(
		// "/s/chopin/e/proj/granules/simonsui/Granules/trunk/bin/MLData.txt");
		File source = new File("/s/chopin/k/grad/simonsui/MLData.txt");
		try {
			BufferedReader fr = new BufferedReader(new FileReader(source));
			String line = fr.readLine();
			int num = 0;
			do {
				line = fr.readLine();
				if (line == null)
					break;
				String[] words = line.split(" ");
				Integer workerNum = Integer.parseInt(words[0]);
				for (int i = 1; i <= numFeatures + 1; i++) {
					a[num][i - 1] = Double.parseDouble(words[i]);
				}
				b[num][0] = Double.parseDouble(words[numFeatures + 1]);

				if (hashMap.containsKey(workerNum)) {
					array.clear();
					for (int i = 0; i < numFeatures + 1; i++) {
						array.add(a[num][i]);
					}
					if (hashMap.get(workerNum).get(0).doubleValue() == array
							.get(0).doubleValue()
							&& hashMap.get(workerNum).get(1).doubleValue() == array
									.get(1).doubleValue()) {
						for (int i = 0; i < hashMap.get(workerNum).size(); i++) {
							System.out.print(hashMap.get(workerNum).get(i)
									+ " ");
						}
						System.out.println(b[num][0]);
					}
					ArrayList<Double> newArray = new ArrayList<Double>();
					newArray.addAll(array);
					hashMap.put(workerNum, newArray);
				} else {
					ArrayList<Double> newArray = new ArrayList<Double>();
					for (int i = 0; i < numFeatures + 1; i++) {
						newArray.add(a[num][i]);
					}
					hashMap.put(workerNum, newArray);
				}
				num++;
			} while (line != "" && line != null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
