package ds.granules.naadsm.event;

public class Checkpoint extends EventType {
	int index;
	int worker_ID;
	int length;
	byte[] bytes;
	byte[] content;
	byte[] temp;
	public float up;
	public float down;
	public float left;
	public float right;

	public Checkpoint() {
		type = EventType.CHECKPOINT;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
	}

	public int getWorkerID() {
		return worker_ID;
	}

	public byte[] addBoundaries() {
		byte[] newBytes = new byte[EventType.EventSize[type] + length + 16];
		bytes = this.marshalling();
		for (int i = 0; i < EventType.EventSize[type] + length; i++) {
			newBytes[i] = bytes[i];
		}
		byte[] t = EventTypeFactory.float2bytes(up);
		newBytes[EventType.EventSize[type] + length] = t[0];
		newBytes[EventType.EventSize[type] + length + 1] = t[1];
		newBytes[EventType.EventSize[type] + length + 2] = t[2];
		newBytes[EventType.EventSize[type] + length + 3] = t[3];
		t = EventTypeFactory.float2bytes(down);
		newBytes[EventType.EventSize[type] + length + 4] = t[0];
		newBytes[EventType.EventSize[type] + length + 5] = t[1];
		newBytes[EventType.EventSize[type] + length + 6] = t[2];
		newBytes[EventType.EventSize[type] + length + 7] = t[3];
		t = EventTypeFactory.float2bytes(left);
		newBytes[EventType.EventSize[type] + length + 8] = t[0];
		newBytes[EventType.EventSize[type] + length + 9] = t[1];
		newBytes[EventType.EventSize[type] + length + 10] = t[2];
		newBytes[EventType.EventSize[type] + length + 11] = t[3];
		t = EventTypeFactory.float2bytes(right);
		newBytes[EventType.EventSize[type] + length + 12] = t[0];
		newBytes[EventType.EventSize[type] + length + 13] = t[1];
		newBytes[EventType.EventSize[type] + length + 14] = t[2];
		newBytes[EventType.EventSize[type] + length + 15] = t[3];
		return newBytes;
	}

	public Checkpoint getBoundaries(byte[] bytes) {
		unmarshalling(bytes);
		byte[] t = new byte[4];
		t[0] = bytes[EventType.EventSize[type] + length];
		t[1] = bytes[EventType.EventSize[type] + length + 1];
		t[2] = bytes[EventType.EventSize[type] + length + 2];
		t[3] = bytes[EventType.EventSize[type] + length + 3];
		up = EventTypeFactory.bytes2float(t);
		t[0] = bytes[EventType.EventSize[type] + length + 4];
		t[1] = bytes[EventType.EventSize[type] + length + 5];
		t[2] = bytes[EventType.EventSize[type] + length + 6];
		t[3] = bytes[EventType.EventSize[type] + length + 7];
		down = EventTypeFactory.bytes2float(t);
		t[0] = bytes[EventType.EventSize[type] + length + 8];
		t[1] = bytes[EventType.EventSize[type] + length + 9];
		t[2] = bytes[EventType.EventSize[type] + length + 10];
		t[3] = bytes[EventType.EventSize[type] + length + 11];
		left = EventTypeFactory.bytes2float(t);
		t[0] = bytes[EventType.EventSize[type] + length + 12];
		t[1] = bytes[EventType.EventSize[type] + length + 13];
		t[2] = bytes[EventType.EventSize[type] + length + 14];
		t[3] = bytes[EventType.EventSize[type] + length + 15];
		right = EventTypeFactory.bytes2float(t);
		return this;
	}

	@Override
	public byte[] marshalling() {
		// TODO Auto-generated method stub
		bytes = new byte[EventType.EventSize[type] + length];
		temp = new byte[4];
		index = 0;
		// temp = EventTypeFactory.int2bytes(EventType.EventSize[type]-4);
		// getNextBytes(4);
		temp = EventTypeFactory.int2bytes(type);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(worker_ID);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(length);
		getNextBytes(4);
		for (int i = 0; i < length; i++) {
			bytes[i + index] = content[i];
		}
		return bytes;
	}

	@Override
	public Checkpoint unmarshalling(byte[] bytes) {
		// TODO Auto-generated method stub
		this.bytes = bytes;
		// if(withLength)
		// index = 8;
		// else
		index = 4;
		getNextValue(4);
		worker_ID = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		length = EventTypeFactory.bytes2int(temp);
		content = new byte[length];
		for (int i = 0; i < length; i++) {
			content[i] = bytes[index + i];
		}
		return this;
	}

	@Override
	public void getNextBytes(int size) {
		for (int i = 0; i < size; i++) {
			bytes[i + index] = temp[i];
		}
		index += size;
	}

	@Override
	public void getNextValue(int size) {
		// TODO Auto-generated method stub
		for (int i = 0; i < size; i++) {
			temp[i] = bytes[i + index];
		}
		index += size;
	}

	@Override
	public int getType() {
		// TODO Auto-generated method stub
		return 12;
	}
}
