package ds.granules.naadsm.event;

public class EndOfDayEvent extends EventType {
	int index;
	int worker_ID;
	int dayNumber;
	boolean finished;
	byte[] bytes;
	byte[] temp;

	public EndOfDayEvent() {
		type = EventType.END_OF_DAY;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
	}
	
	public boolean isFinished(){
		return finished;
	}
	
	public int getWorkerID(){
		return worker_ID;
	}
	
	public int getDayNumber(){
		return dayNumber;
	}
	
	@Override
	public byte[] marshalling() {
		// TODO Auto-generated method stub
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
		index = 0;
//		temp = EventTypeFactory.int2bytes(EventType.EventSize[type]-4);
//		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(type);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(worker_ID);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(dayNumber);
		getNextBytes(4);
		if (finished)
			temp[0] = 1;
		else
			temp[0] = 0;
		getNextBytes(1);
		return bytes;
	}

	@Override
	public EndOfDayEvent unmarshalling(byte[] bytes) {
		// TODO Auto-generated method stub
		this.bytes=bytes;
//		if(withLength)
//			index = 8;
//		else
		index = 4;
		getNextValue(4);
		worker_ID = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		dayNumber = EventTypeFactory.bytes2int(temp);
		getNextValue(1);
		if (temp[0] == 0)
			finished = false;
		else
			finished = true;
		return this;
	}

	@Override
	public void getNextBytes(int size) {
		for (int i = 0; i < size; i++) {
			bytes[i + index] = temp[i];
		}
		index += size;
	}

	@Override
	public void getNextValue(int size) {
		// TODO Auto-generated method stub
		for (int i = 0; i < size; i++) {
			temp[i] = bytes[i + index];
		}
		index += size;
	}

	@Override
	public int getType() {
		// TODO Auto-generated method stub
		return 1;
	}

}
