package ds.granules.naadsm.event;

import java.io.Serializable;

public class EventType implements Serializable{
	public static int START_NEW_DAY = 0;
	public static int END_OF_DAY = 1;
	public static int END_OF_SIMULATION = 2;
	public static int EXPOSURE = 3;
	public static int PUBLIC_ANNOUNCEMENT = 4;
	public static int QUARANTINE = 5;
	public static int DESTRUCTION = 6;
	public static int SPLIT = 7;
	public static int TRACE_RESULT = 8;
	public static int REQUEST_OF_DESTRUCTION = 9;
	public static int ATTEMPT_TO_INFECT = 10;
	public static int REQUEST_FOR_ZONE_FOCUS = 11;
	public static int CHECKPOINT = 12;
	public static int RESTORE = 13;
	public static int[] EventSize = { 12, 13, 4, 26, 12, 16, 16, 16, 28, 24, 40, 16, 12, 12};
	int type;

	public int getType() {
		return type;
	}

	void getNextBytes(int size) {

	}

	public byte[] marshalling() {
		switch (type) {
		case 0:
			StartNewDayEvent startNewDayEvent = (StartNewDayEvent) this;
			return startNewDayEvent.marshalling();
		case 1:
			EndOfDayEvent endOfDayEvent = (EndOfDayEvent) this;
			return endOfDayEvent.marshalling();
		case 2:
			EndOfSimulationEvent endOfSimulationEvent = (EndOfSimulationEvent) this;
			return endOfSimulationEvent.marshalling();
		case 3:
			ExposureEvent exposureEvent = (ExposureEvent) this;
			return exposureEvent.marshalling();
		case 4:
			PublicAnnouncementEvent publicAnnoucementEvent = (PublicAnnouncementEvent) this;
			return publicAnnoucementEvent.marshalling();
		case 5:
			QuarantineEvent quarantineEvent = (QuarantineEvent) this;
			return quarantineEvent.marshalling();
		case 6:
			DestructionEvent destructionEvent = (DestructionEvent) this;
			return destructionEvent.marshalling();
		case 7:
			SplitEvent splitEvent = (SplitEvent) this;
			return splitEvent.marshalling();
		case 8:
			TraceResult traceResult = (TraceResult) this;
			return traceResult.marshalling();
		case 9:
			RequestOfDestruction requestOfDestruction = (RequestOfDestruction) this;
			return requestOfDestruction.marshalling();
		case 10:
			AttemptToInfect attemptToInfect = (AttemptToInfect) this;
			return attemptToInfect.marshalling();
		case 11:
			RequestForZoneFocus requestForZoneFocus = (RequestForZoneFocus) this;
			return requestForZoneFocus.marshalling();
		case 12:
			Checkpoint checkpoint = (Checkpoint) this;
			return checkpoint.marshalling();
		case 13:
			Restore restore = (Restore) this;
			return restore.marshalling();
		}
		return null;
	}

	public EventType unmarshalling(byte[] bytes) {
		EventType eventType = null;
		byte[] temp = new byte[4];
//		if (withLength) {
//			temp[0] = bytes[4];
//			temp[1] = bytes[5];
//			temp[2] = bytes[6];
//			temp[3] = bytes[7];
//		} else {
		temp[0] = bytes[0];
		temp[1] = bytes[1];
		temp[2] = bytes[2];
		temp[3] = bytes[3];
//		}
		int type = EventTypeFactory.bytes2int(temp);
		switch (type) {
		case 0:
			StartNewDayEvent startNewDayEvent = new StartNewDayEvent();
			eventType = startNewDayEvent.unmarshalling(bytes);
			break;
		case 1:
			EndOfDayEvent endOfDayEvent = new EndOfDayEvent();
			eventType = endOfDayEvent.unmarshalling(bytes);
			break;
		case 2:
			EndOfSimulationEvent endOfSimulationEvent = new EndOfSimulationEvent();
			eventType = endOfSimulationEvent.unmarshalling(bytes);
			break;
		case 3:
			ExposureEvent exposureEvent = new ExposureEvent();
			eventType = exposureEvent.unmarshalling(bytes);
			break;
		case 4:
			PublicAnnouncementEvent publicAnnoucementEvent = new PublicAnnouncementEvent();
			eventType = publicAnnoucementEvent.unmarshalling(bytes);
			break;
		case 5:
			QuarantineEvent quarantineEvent = new QuarantineEvent();
			eventType = quarantineEvent.unmarshalling(bytes);
			break;
		case 6:
			DestructionEvent destructionEvent = new DestructionEvent();
			eventType = destructionEvent.unmarshalling(bytes);
			break;
		case 7:
			SplitEvent splitEvent = new SplitEvent();
			eventType = splitEvent.unmarshalling(bytes);
			break;
		case 8:
			TraceResult traceResult = new TraceResult();
			eventType = traceResult.unmarshalling(bytes);
			break;
		case 9:
			RequestOfDestruction requestOfDestruction = new RequestOfDestruction();
			eventType = requestOfDestruction.unmarshalling(bytes);
			break;
		case 10:
			AttemptToInfect attemptToInfect = new AttemptToInfect();
			eventType = attemptToInfect.unmarshalling(bytes);
			break;
		case 11:
			RequestForZoneFocus requestForZoneFocus = new RequestForZoneFocus();
			eventType = requestForZoneFocus.unmarshalling(bytes);
			break;
		case 12:
			Checkpoint checkpoint = new Checkpoint();
			eventType = checkpoint.unmarshalling(bytes);
			break;
		case 13:
			Restore restore = new Restore();
			eventType = restore.unmarshalling(bytes);
			break;
		}
		return eventType;
	}

	public void getNextValue(int size) {

	}

}
