package ds.granules.naadsm.event;

public class EventTypeFactory {

	public static EventType createEventType(byte[] bytes) {
		EventType eventType = null;
		try {
			byte[] temp = new byte[4];
			// if (withLength) {
			// temp[0] = bytes[4];
			// temp[1] = bytes[5];
			// temp[2] = bytes[6];
			// temp[3] = bytes[7];
			// } else {
			temp[0] = bytes[0];
			temp[1] = bytes[1];
			temp[2] = bytes[2];
			temp[3] = bytes[3];
			// }
			int type = bytes2int(temp);
			switch (type) {
			case 0:
				StartNewDayEvent startNewDayEvent = new StartNewDayEvent();
				eventType = startNewDayEvent.unmarshalling(bytes);
				break;
			case 1:
				EndOfDayEvent endOfDayEvent = new EndOfDayEvent();
				eventType = endOfDayEvent.unmarshalling(bytes);
				break;
			case 2:
				EndOfSimulationEvent endOfSimulationEvent = new EndOfSimulationEvent();
				eventType = endOfSimulationEvent.unmarshalling(bytes);
				break;
			case 3:
				ExposureEvent exposureEvent = new ExposureEvent();
				eventType = exposureEvent.unmarshalling(bytes);
				break;
			case 4:
				PublicAnnouncementEvent publicAnnoucementEvent = new PublicAnnouncementEvent();
				eventType = publicAnnoucementEvent.unmarshalling(bytes);
				break;
			case 5:
				QuarantineEvent quarantineEvent = new QuarantineEvent();
				eventType = quarantineEvent.unmarshalling(bytes);
				break;
			case 6:
				DestructionEvent destructionEvent = new DestructionEvent();
				eventType = destructionEvent.unmarshalling(bytes);
				break;
			case 7:
				SplitEvent splitEvent = new SplitEvent();
				eventType = splitEvent.unmarshalling(bytes);
				break;
			case 8:
				TraceResult traceResult = new TraceResult();
				eventType = traceResult.unmarshalling(bytes);
				break;
			case 9:
				RequestOfDestruction requestOfDestruction = new RequestOfDestruction();
				eventType = requestOfDestruction.unmarshalling(bytes);
				break;
			case 10:
				AttemptToInfect attemptToInfect = new AttemptToInfect();
				eventType = attemptToInfect.unmarshalling(bytes);
				break;
			case 11:
				RequestForZoneFocus requestForZoneFocus = new RequestForZoneFocus();
				eventType = requestForZoneFocus.unmarshalling(bytes);
				break;
			case 12:
				Checkpoint checkpoint = new Checkpoint();
				eventType = checkpoint.unmarshalling(bytes);
				break;
			case 13:
				Restore restore = new Restore();
				eventType = restore.unmarshalling(bytes);
				break;
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		return eventType;
	}

	public static int bytes2int(byte[] b) {
		// int mask = 0xff;
		// int temp = 0;
		// int res = 0;
		// for (int i = 0; i < 4; i++) {
		// res <<= 8;
		// temp = b[i] & mask;
		// res |= temp;
		// }
		// return res;
		return getInt(b);
	}

	public static byte[] int2bytes(int num) {
		// byte b[] = new byte[4];
		// for (int i = 0; i < 4; i++) {
		// b[i] = (byte) (num >>> (24 - i * 8));
		// }
		// return b;
		return getBytes(num);
	}

	/**
	 * Returns the bytes that are associated with an integer value.
	 * 
	 * @param value
	 *            The integer for which we are seeking an equivalent byte stream
	 *            representation.
	 * @return The int value as a sequence of bytes
	 */
	public static byte[] getBytes(int value) {
		byte[] temp = new byte[4];
		temp[0] = (byte) ((value >>> 24) & 0xFF);
		temp[1] = (byte) ((value >>> 16) & 0xFF);
		temp[2] = (byte) ((value >>> 8) & 0xFF);
		temp[3] = (byte) ((value >>> 0) & 0xFF);
		return temp;
	}

	/**
	 * Given a sequence of bytes, this method returns the int value associated
	 * with the sequence of bytes. This sequence of bytes passed as the argument
	 * should be of length=4.
	 * 
	 * @param data
	 *            The sequence of bytes representing a int value.
	 * @return The integer value associated with the sequence of bytes
	 */
	public static int getInt(byte[] data) {
		int w, x, y, z;
		w = data[0];
		x = data[1];
		y = data[2];
		z = data[3];
		if (w < 0)
			w += 256;
		if (x < 0)
			x += 256;
		if (y < 0)
			y += 256;
		if (z < 0)
			z += 256;
		return ((w << 24) + (x << 16) + (y << 8) + (z << 0));
	}

	public static byte[] float2bytes(float num) {
		int IEEE754 = Float.floatToIntBits(num);
		return EventTypeFactory.int2bytes(IEEE754);
	}

	public static float bytes2float(byte[] bytes) {
		int IEEE754 = EventTypeFactory.bytes2int(bytes);
		return Float.intBitsToFloat(IEEE754);
	}
}
