package ds.granules.naadsm.event;

public class ExposureEvent extends EventType {

	int index;
	int worker_ID;
	int dayNumber;
	int indexExposingHerd;
	int indexExposedHerd;
	int contactType;
	boolean adequate;
	boolean traceable;

	byte[] bytes;
	byte[] temp;

	public int getWorkerID() {
		return worker_ID;
	}

	public int getDayNumber() {
		return dayNumber;
	}

	public int getIndexExposingHerd() {
		return indexExposingHerd;
	}

	public int getIndexExposedHerd() {
		return indexExposedHerd;
	}

	public int getContactType() {
		return contactType;
	}

	public boolean isAdequate() {
		return adequate;
	}

	public boolean isTraceable() {
		return traceable;
	}

	public ExposureEvent() {
		type = EventType.EXPOSURE;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
	}

	@Override
	public byte[] marshalling() {
		// TODO Auto-generated method stub
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
		index = 0;
		// temp = EventTypeFactory.int2bytes(EventType.EventSize[type]-4);
		// getNextBytes(4);
		temp = EventTypeFactory.int2bytes(type);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(worker_ID);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(dayNumber);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(indexExposingHerd);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(indexExposedHerd);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(contactType);
		getNextBytes(4);
		if (adequate)
			temp[0] = 1;
		else
			temp[0] = 0;
		getNextBytes(1);
		if (traceable)
			temp[0] = 1;
		else
			temp[0] = 0;
		getNextBytes(1);
		return bytes;
	}

	@Override
	public ExposureEvent unmarshalling(byte[] bytes) {
		// TODO Auto-generated method stub
		this.bytes = bytes;
		// if(withLength)
		// index = 8;
		// else
		index = 4;
		getNextValue(4);
		worker_ID = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		dayNumber = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		indexExposingHerd = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		indexExposedHerd = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		contactType = EventTypeFactory.bytes2int(temp);
		getNextValue(1);
		if (temp[0] == 0)
			adequate = false;
		else
			adequate = true;
		getNextValue(1);
		if (temp[0] == 0)
			traceable = false;
		else
			traceable = true;
		return this;
	}

	@Override
	public void getNextBytes(int size) {
		for (int i = 0; i < size; i++) {
			bytes[i + index] = temp[i];
		}
		index += size;
	}

	@Override
	public void getNextValue(int size) {
		// TODO Auto-generated method stub
		for (int i = 0; i < size; i++) {
			temp[i] = bytes[i + index];
		}
		index += size;
	}

	@Override
	public int getType() {
		// TODO Auto-generated method stub
		return 3;
	}

}
