package ds.granules.naadsm.event;

public class SplitEvent extends EventType {
	int index;
	public int worker_ID;
	public int howToSplit;
	public float coordinate;
	byte[] bytes;
	byte[] temp;

	public SplitEvent() {
		type = EventType.SPLIT;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
	}

	public SplitEvent(int worker, int way, float where) {
		type = EventType.SPLIT;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
		worker_ID = worker;
		howToSplit = way;
		coordinate = where;
	}

	public int getWorkerID() {
		return worker_ID;
	}

	@Override
	public byte[] marshalling() {
		// TODO Auto-generated method stub
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
		index = 0;
//		temp = EventTypeFactory.int2bytes(EventType.EventSize[type] - 4);
//		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(type);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(worker_ID);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(howToSplit);
		getNextBytes(4);
		temp = EventTypeFactory.float2bytes(coordinate);
		getNextBytes(4);
		return bytes;
	}

	@Override
	public SplitEvent unmarshalling(byte[] bytes) {
		// TODO Auto-generated method stub
		this.bytes = bytes;
		// if(withLength)
		// index = 8;
		// else
		index = 4;
		getNextValue(4);
		worker_ID = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		howToSplit = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		coordinate = EventTypeFactory.bytes2float(temp);
		return this;
	}

	@Override
	public void getNextBytes(int size) {
		for (int i = 0; i < size; i++) {
			bytes[i + index] = temp[i];
		}
		index += size;
	}

	@Override
	public void getNextValue(int size) {
		// TODO Auto-generated method stub
		for (int i = 0; i < size; i++) {
			temp[i] = bytes[i + index];
		}
		index += size;
	}

	@Override
	public int getType() {
		// TODO Auto-generated method stub
		return 7;
	}
}
