/**
 * Software License, Version 1.0
 * 
 * Copyright 2010 Colorado State University.  All rights reserved.
 * 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1) All redistributions of source code must retain the above copyright notice,
 *  the list of authors in the original source code, this list of conditions and
 *  the disclaimer listed in this license;
 * 2) All redistributions in binary form must reproduce the above copyright 
 *  notice, this list of conditions and the disclaimer listed in this license in
 *  the documentation and/or other materials provided with the distribution;
 * 3) Any documentation included with all redistributions must include the 
 * following acknowledgment:
 *
 *"This product includes software developed by the Department of Computer Science 
 * at Colorado State University. For further information contact the department at 
 * http://www.cs.colostate.edu/."
 *
 * Alternatively, this acknowledgment may appear in the software itself, and 
 * wherever such third-party acknowledgments normally appear.
 * 
 * 4) The name Colorado State University or Granules shall not be used to endorse
 * or promote products derived from this software without prior written permission
 * from Colorado State University.  For written permission, please contact the 
 * Computer Science Department at 1100 Center Avenue, Fort Collins, CO 80523-1873.
 * 5) Products derived from this software may not be called Granules, 
 * nor may Colorado State University or Granules appear in their name, without prior
 * written permission of ARTI.
 * 
 *
 * Colorado State University provides no reassurances that the source code provided 
 * does not infringe the patent or any other intellectual property rights of 
 * any other entity.  Colorado State University disclaims any liability to any 
 * recipient for claims brought by any other entity based on infringement of 
 * intellectual property rights or otherwise.  
 *
 * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO 
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. COLORADO STATE UNIVERSITY GIVES
 * NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF 
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS. 
 * COLORADO STATE UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS", 
 * "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.  
 * LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR 
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION 
 * GENERATED USING SOFTWARE.
 */
package ds.granules.naadsm.portionaldynamicmerge.event;

/**
 * CHECKPOINT message
 * 
 * @author simonsui
 * 
 */
public class Checkpoint extends EventType {
	int index;
	int worker_ID;
	int length;
	byte[] bytes;
	byte[] content;
	byte[] temp;
//	public float up;
//	public float down;
//	public float left;
//	public float right;

	public Checkpoint() {
		type = EventType.CHECKPOINT;
		index = 0;
		bytes = new byte[EventType.EventSize[type]];
		temp = new byte[4];
	}

	public int getWorkerID() {
		return worker_ID;
	}

	public void setWorker_ID(int num) {
		worker_ID = num;
	}
	
	public void setContent(byte[] content){
		length = content.length;
		this.content = content;
	}
	
	public byte[] getContent() {
		return content;
	}
	
	public int getLength() {
		return length;
	}
	
//	public byte[] addBoundaries() {
//		byte[] newBytes = new byte[EventType.EventSize[type] + length + 16];
//		bytes = this.marshalling();
//		for (int i = 0; i < EventType.EventSize[type] + length; i++) {
//			newBytes[i] = bytes[i];
//		}
//		byte[] t = EventTypeFactory.float2bytes(up);
//		newBytes[EventType.EventSize[type] + length] = t[0];
//		newBytes[EventType.EventSize[type] + length + 1] = t[1];
//		newBytes[EventType.EventSize[type] + length + 2] = t[2];
//		newBytes[EventType.EventSize[type] + length + 3] = t[3];
//		t = EventTypeFactory.float2bytes(down);
//		newBytes[EventType.EventSize[type] + length + 4] = t[0];
//		newBytes[EventType.EventSize[type] + length + 5] = t[1];
//		newBytes[EventType.EventSize[type] + length + 6] = t[2];
//		newBytes[EventType.EventSize[type] + length + 7] = t[3];
//		t = EventTypeFactory.float2bytes(left);
//		newBytes[EventType.EventSize[type] + length + 8] = t[0];
//		newBytes[EventType.EventSize[type] + length + 9] = t[1];
//		newBytes[EventType.EventSize[type] + length + 10] = t[2];
//		newBytes[EventType.EventSize[type] + length + 11] = t[3];
//		t = EventTypeFactory.float2bytes(right);
//		newBytes[EventType.EventSize[type] + length + 12] = t[0];
//		newBytes[EventType.EventSize[type] + length + 13] = t[1];
//		newBytes[EventType.EventSize[type] + length + 14] = t[2];
//		newBytes[EventType.EventSize[type] + length + 15] = t[3];
//		return newBytes;
//	}

//	public Checkpoint getBoundaries(byte[] bytes) {
//		unmarshalling(bytes);
//		byte[] t = new byte[4];
//		t[0] = bytes[EventType.EventSize[type] + length];
//		t[1] = bytes[EventType.EventSize[type] + length + 1];
//		t[2] = bytes[EventType.EventSize[type] + length + 2];
//		t[3] = bytes[EventType.EventSize[type] + length + 3];
//		up = EventTypeFactory.bytes2float(t);
//		t[0] = bytes[EventType.EventSize[type] + length + 4];
//		t[1] = bytes[EventType.EventSize[type] + length + 5];
//		t[2] = bytes[EventType.EventSize[type] + length + 6];
//		t[3] = bytes[EventType.EventSize[type] + length + 7];
//		down = EventTypeFactory.bytes2float(t);
//		t[0] = bytes[EventType.EventSize[type] + length + 8];
//		t[1] = bytes[EventType.EventSize[type] + length + 9];
//		t[2] = bytes[EventType.EventSize[type] + length + 10];
//		t[3] = bytes[EventType.EventSize[type] + length + 11];
//		left = EventTypeFactory.bytes2float(t);
//		t[0] = bytes[EventType.EventSize[type] + length + 12];
//		t[1] = bytes[EventType.EventSize[type] + length + 13];
//		t[2] = bytes[EventType.EventSize[type] + length + 14];
//		t[3] = bytes[EventType.EventSize[type] + length + 15];
//		right = EventTypeFactory.bytes2float(t);
//		return this;
//	}

	@Override
	public byte[] marshalling() {
		bytes = new byte[EventType.EventSize[type] + length];
		temp = new byte[4];
		index = 0;
		temp = EventTypeFactory.int2bytes(type);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(worker_ID);
		getNextBytes(4);
		temp = EventTypeFactory.int2bytes(length);
		getNextBytes(4);
		for (int i = 0; i < length; i++) {
			bytes[i + index] = content[i];
		}
		return bytes;
	}

	@Override
	public Checkpoint unmarshalling(byte[] bytes) {
		this.bytes = bytes;
		index = 4;
		getNextValue(4);
		worker_ID = EventTypeFactory.bytes2int(temp);
		getNextValue(4);
		length = EventTypeFactory.bytes2int(temp);
		content = new byte[length];
		for (int i = 0; i < length; i++) {
			content[i] = bytes[index + i];
		}
		return this;
	}

	@Override
	public void getNextBytes(int size) {
		for (int i = 0; i < size; i++) {
			bytes[i + index] = temp[i];
		}
		index += size;
	}

	@Override
	public void getNextValue(int size) {
		for (int i = 0; i < size; i++) {
			temp[i] = bytes[i + index];
		}
		index += size;
	}

	@Override
	public int getType() {
		return 12;
	}
}
