package ds.granules.naadsm;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.encog.ml.data.MLData;
import org.encog.ml.data.MLDataPair;
import org.encog.ml.data.MLDataSet;
import org.encog.ml.data.basic.BasicMLDataSet;
import org.encog.ml.train.MLTrain;
import org.encog.neural.networks.BasicNetwork;
import org.encog.neural.networks.layers.BasicLayer;
import org.encog.neural.networks.training.propagation.resilient.ResilientPropagation;
import org.encog.util.obj.SerializeObject;

import ds.granules.naadsm.dynamicmerge.event.OutputVariableValue;

public class testIO {

	/**
	 * @param args
	 * @throws IOException
	 * @throws ClassNotFoundException
	 */
	public static void main(String[] args) throws IOException,
			ClassNotFoundException {
		// TODO Auto-generated method stub
		File source = new File(
				"/s/chopin/e/proj/granules/simonsui/Granules/trunk/bin/MLData1.txt");
		int numSamples = 0;
		try {
			BufferedReader fr = new BufferedReader(new FileReader(source));
			String line;
			do {
				line = fr.readLine();
				numSamples++;
			} while (line != "" && line != null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		numSamples--;
		int numFeatures = OutputVariableValue.VAR_NUM;
		double x[][] = new double[numSamples][numFeatures];
		double y[][] = new double[numSamples][1];
		double maxX[] = new double[numFeatures];
		double minX[] = new double[numFeatures];
		for (int i = 0; i < numFeatures; i++) {
			maxX[i] = Double.MIN_VALUE;
			minX[i] = Double.MAX_VALUE;
		}
		double maxY = Double.MIN_VALUE;
		double minY = Double.MAX_VALUE;
		try {
			BufferedReader fr = new BufferedReader(new FileReader(source));
			String line;
			int num = 0;
			do {
				line = fr.readLine();
				if (line == null)
					break;
				String[] words = line.split(" ");
				for (int i = 0; i < numFeatures; i++) {
					x[num][i] = Double.parseDouble(words[i]);
					if (maxX[i] < x[num][i])
						maxX[i] = x[num][i];
					if (minX[i] > x[num][i])
						minX[i] = x[num][i];
				}
				y[num][0] = Double.parseDouble(words[numFeatures]);
				if (maxY < y[num][0])
					maxY = y[num][0];
				if (minY > y[num][0])
					minY = y[num][0];
				num++;
			} while (line != "" && line != null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		double[][] normalX = new double[numSamples][numFeatures];
		double[][] normalY = new double[numSamples][1];

		for (int i = 0; i < numSamples; i++) {
			for (int j = 0; j < numFeatures; j++) {
				normalX[i][j] = (x[i][j] - minX[j]) / (maxX[j] - minX[j]);
			}
			normalY[i][0] = (y[i][0] - minY) / (maxY - minY);
			if (normalY[i][0] < 0)
				System.out.println(i);
			System.out.println("Y=" + y[i][0]);
		}
		BasicNetwork network = new BasicNetwork();
		network.addLayer(new BasicLayer(null, true, 4));
		// network.addLayer(new BasicLayer(15));
		// network.addLayer(new BasicLayer(10));
		network.addLayer(new BasicLayer(8));
		network.addLayer(new BasicLayer(null, false, 1));
		network.getStructure().finalizeStructure();
		network.reset();

		SerializeObject obj;
		SerializeObject.save(new File("a.txt"), network);

		BasicNetwork newNetwork = (BasicNetwork) SerializeObject.load(new File(
				"a.txt"));

		double[][] trainX = new double[numSamples / 2 + 1][numFeatures];
		double[][] trainY = new double[numSamples / 2 + 1][1];
		double[][] testX = new double[numSamples / 2 + 1][numFeatures];
		double[][] testY = new double[numSamples / 2 + 1][1];
		for (int i = 0; i < numSamples; i += 2) {
			for (int j = 0; j < numFeatures; j++) {
				trainX[i / 2][j] = normalX[i][j];
				if (i + 1 < numSamples)
					testX[i / 2][j] = normalX[i + 1][j];
			}
			trainY[i / 2][0] = normalY[i][0];
			if (i + 1 < numSamples)
				testY[i / 2][0] = normalY[i + 1][0];
		}
		MLDataSet trainingSet = new BasicMLDataSet(trainX, trainY);
		MLDataSet testSet = new BasicMLDataSet(testX, testY);
		MLTrain train = new ResilientPropagation(newNetwork, trainingSet);

		double error;
		do {
			error = train.getError();
			train.iteration();
			System.out.println(train.getError());
		} while (Math.abs(train.getError() - error) > 1e-10);
		for (MLDataPair pair : testSet) {
			MLData output = newNetwork.compute(pair.getInput());
			System.out.print(output.getData(0) * (maxY - minY) + minY + "  ");
			System.out.println(pair.getIdeal().getData(0) * (maxY - minY)
					+ minY);
			// System.out.println(output.getData(0) /
			// pair.getIdeal().getData(0));
		}
		// System.out.println("--------------------------------");
		// for (MLDataPair pair : trainingSet) {
		// MLData output = network.compute(pair.getInput());
		// System.out.print(output.getData(0) + ":");
		// System.out.println(pair.getIdeal().getData(0));
		// }

	}
}
