#main fn for fib example

import sys
import socket
from construct import *
from javaMessage import *
import fibWrap

if(len(sys.argv) == 1): #only the command, so assume using pipes
	cin = sys.stdin
	cout = sys.stdout
	cerr = sys.stderr
else:
	port = sys.argv[1] #get port info
	#keep as default for now - fix when more awake
	mySoc = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
	mySoc.connect(('localhost',int(port)))
	f = mySoc.makefile()
	cin = f
	cout = f
	cerr = sys.stderr
	cerr.write("is sockety\n")
	cerr.flush()

cerr.write("starting up\n")
cerr.flush()
jm  = javaMessage()
while(True):
	cerr.write("Running\n")
	cerr.flush()
	insize = cin.read(4) #figure out how long the message is
	length = SBInt32("size").parse(insize)
	incoming = cin.read(length)
	msg = jm.JMConvert.parse(incoming)
	mtype = msg.MessageType
	if(mtype=="INITIALIZE"):
		fw = fibWrap.fibWrap(msg)
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data="initialized")]))
		retMsg = jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID="bah",Description="returning",fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()
	elif(mtype=="DATA"):
		cerr.write("DATA msg\n")
		cerr.flush()
		#run the fib command, and send back result ++ timing
		fw.run(msg)
		cerr.write("done running\n")
		cerr.flush()
		retMsg = fw.getResults()
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()
	elif(mtype=="START_STOP"):
		cerr.write("START_STOP msg\n")
		cerr.flush()
		##same as DATA, just different message type
		fw.run(msg)
		cerr.write("Done Running\n")
		cerr.flush()
		retMsg = fw.getResults()
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()
	else:
		cerr.write("Unhandled msg type...")
		cerr.write("\nmtype: " + str(mtype) + "\n")
		cerr.flush()
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=fw.status)]))
		retMsg = jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=fw.stream,Description=fw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()

