package ds.granules.samples.kmeans;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import ds.granules.exception.MarshallingException;

/**
 * Object marshalling and unmarshalling utility used for Kmeans clustering.
 * 
 * @author Jaliya Ekanayake
 * 
 */
public class ObjectMarshaller {

    public static byte[] getBytes(Serializable obj) throws MarshallingException {
        try {
            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bout);
            oos.writeObject(obj);
            return bout.toByteArray();

        } catch (Exception e) {
            // better to send the entire stack trace.
            throw new MarshallingException(e.getMessage());
        }
    }


    public static Serializable fromBytes(byte[] bytes)
        throws MarshallingException {
        try {
            ByteArrayInputStream bin = new ByteArrayInputStream(bytes);
            ObjectInputStream ois = new ObjectInputStream(bin);
            return (Serializable) ois.readObject();
        } catch (Exception e) {
            // better to send the entire stack trace.
            throw new MarshallingException(e.getMessage());
        }
    }
}
