#Code to be called by mappers

from PIL import Image, ImageStat
from collections import namedtuple
from closest import closest
from construct import *
import sys

Box = namedtuple("Box","left upper right lower")

#takes the image file name, box size(tuple:widthxheight), zoomMultiplier (for better resolution), the map index, and the total number of maps - defines which grid 'squares' it's responsible for determining the color of
def makeCollage(image, boxSize, zoomMult, mapInd, numMaps):

	orig = Image.open(image)

	oSize = orig.size

	#blow up a copy
	p = orig.copy()
	p = p.resize((oSize[0] * zoomMult, oSize[1] * zoomMult))

	width = p.size[0]
	height = p.size[1]

	split = boxSize

	horzSplit = range(0,width,split[0])
	vertSplit = range(0,height,split[1])

	boxList = []

	for i in horzSplit:
		for j in vertSplit:
			b = Box(i, j, i+split[0], j+split[1])
			boxList.append(b)
		
	colorList = []

	#loop through the boxes you're responsible for
	for box in boxList[mapInd:len(boxList):numMaps]:
		sys.stderr.write("*")
		sys.stderr.flush()
		piece = p.crop(box)
		sp = piece.split()
		hs = []
		for g in sp: #split into rgb channels
			hs.append(g.histogram()) #grab histogram for each band
		RGB = []
		for i in hs:
			RGB.append(i.index(max(i)))
		colorList.append(Container(DataType="STRING",data=closest(RGB)))

	return colorList
