#Code to be called by reducer
#gets lists of colors from mappers - the reducer initially grabs good images
#for each color, then when receiving lists from the mappers, simply inserts the
#correct image in the correct position

from PIL import Image, ImageStat
from collections import namedtuple
import closest
import urllib
from googleThing import getURL, getGoodURL
import sys

Box = namedtuple("Box","left upper right lower")

class imgCompiler:
	def __init__(self,img,numMaps,zoomMult,boxSize,description):
		self.pic = Image.open(img)
		self.mapCnt = numMaps
		self.zoom = zoomMult
		self.bSize = boxSize
		self.topic = description
		
		oSize = self.pic.size
		self.cpy=self.pic.copy()
		self.cpy = self.cpy.resize((oSize[0] * zoomMult, oSize[1] * zoomMult))

		width = self.cpy.size[0]
		height = self.cpy.size[1]

		horzSplit = range(0,width,self.bSize[0])
		vertSplit = range(0,height,self.bSize[1])

		self.boxList = []

		#still need to build a boxlist
		for i in horzSplit:
			for j in vertSplit:
				b = Box(i, j, i+self.bSize[0], j+self.bSize[1])
				self.boxList.append(b)

		clist = closest.cnames
		self.imgCols = []
		for c in clist:
			sys.stderr.write("c: " + str(c) + "\n")
			sys.stderr.flush()
			gurl = getGoodURL(c,self.topic)
			iti = gurl.rfind('.')
			itype = gurl[iti+1:]
			tempImg = urllib.URLopener()
			tname = '/tmp/tmp.' + c + '.'+ itype
			sys.stderr.write("tname: " + tname + "\n")
			fh = tempImg.retrieve(gurl,tname)
			tImg = Image.open(tname)
			tImg = tImg.resize(self.bSize)
			self.imgCols.append(tImg)
		
	#colors will be a list of colors - cleaned up from the colMap output
	def addImages(self,mapID,colors):
		i = 0
		sys.stderr.write("len(colors): " + str(len(colors)) + "\n")
		sys.stderr.flush()
		for box in self.boxList[int(mapID):len(self.boxList):int(self.mapCnt)]:
			sys.stderr.write("i: " + str(i) + "\n")
			sys.stderr.flush()
			newp = self.imgCols[closest.cnames.index(colors[i])]
			self.cpy.paste(newp,box)
			i+=1

	def saveResult(self, fname):
		self.cpy = self.cpy.resize(self.pic.size)
		self.cpy.save(fname)
