#main entrance point to mappers for unnamed pipes

import sys
from construct import *
from javaMessage import *
import colWrap
import time

cin = sys.stdin
cout = sys.stdout
cerr = sys.stderr

cerr.write("starting up...")
cerr.flush()
jm = javaMessage()
#cmw = colWrap.colMapWrap()
while(True):
	insize = cin.read(4) #read in 4 bytes
	length = SBInt32("size").parse(insize)
	incoming = cin.read(length)
	msg = jm.JMConvert.parse(incoming)
	mtype = msg.MessageType
	if(mtype=="INITIALIZE"):
		cmw = colWrap.colMapWrap(msg)
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=cmw.status)]))
		retMsg = jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=cmw.stream,Description=cmw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()
	elif(mtype=="START_STOP"):
		cmw.run(msg)
		#r = jm.finalBuild.build(Container(length=len(cmw.getResults()),data = cmw.getResults()))
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=cmw.status)]))
		retMsg = jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=cmw.stream,Description=cmw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()
	elif(mtype=="ABORT"):
		cerr.write("Killing")
		break
	elif(mtype=="RESULTS"):
		j = cmw.getResults()
		r = jm.finalBuild.build(Container(length=len(j),data=j))
		cout.write(r)
		cout.flush()
	else:
		cerr.write("Unhandled msg type...")
		retData = jm.dataBlock.build(Container(readOne=[Container(DataType="STRING",data=cmw.status)]))
		retMsg = jm.JMConvert.build(Container(MessageType="STATUS",IOArray=[Container(length=len(msg.IOArray[0].data),data=msg.IOArray[0].data),Container(length=len(retData),data=retData)],StreamID=cmw.stream,Description=cmw.status,fromJava=False))
		r = jm.finalBuild.build(Container(length=len(retMsg),data=retMsg))
		cout.write(r)
		cout.flush()

